SuperStrict

' Blind Zombie Hunter - Holzchopf

Framework BRL.GLMax2D
Import BRL.FreeAudioAudio
Import BRL.OGGLoader
Import BRL.Timer
Import BRL.Random
Import BRL.LinkedList

Local tmr:TTimer = CreateTimer(50)
Global gw%,gh%
Global sBrt:TSound[3],sDrp:TSound,sDry:TSound,sExp:TSound,sLck:TSound,sPch:TSound,sSht:TSound,sStp:TSound[8],sWsh:TSound
Global ms%=MilliSecs()

SeedRnd ms
LGfx()
LSound()

Global chn:TList=New TList
Global plr:TPlr=New TPlr
plr.ammo=7
plr.a=Rand(0,359)
plr.pp.a=plr.a
plr.pp.x=plr.x
plr.pp.y=plr.y
Global car:TPos=New TPos
car.x=800
Global zmb:TZmb[]
For Local i%=0 Until 50
	Local z:TZmb=New TZmb
	z.a=Rand(0,359)
	z.x=Rand(100,1200)
	z.y=Rand(-400,400)
	z.pp.a=z.a
	z.pp.x=z.x
	z.pp.y=z.y
	z.s=12
	z.tm=ms+Rand(0,20000)
	z.tb=ms+Rand(0,5000)
	z.bi=Rand(4000,6000)
	zmb:+[z]
Next

MoveMouse(gw/2,gh/2)
MouseXSpeed()
While Not KeyHit(KEY_ESCAPE)
	plr.Update()
	For Local z:TZmb=EachIn zmb
		z.Update()
	Next
	For Local c:TChn=EachIn chn
		If Not ChannelPlaying(c.c)
			StopChannel(c.c)
			chn.Remove(c)
		Else
			c.Adjust()
		EndIf
	Next
	WaitTimer(tmr)
Wend
End

Type TChn
	Field c:TChannel
	Field p:TPos
	Field v#,e#
	Method New()
		c=AllocChannel()
		chn.AddLast(Self)
	End Method
	Method Adjust()
		Local ax#=Sin(plr.a),ay#=-Cos(plr.a)
		Local dx#=plr.x-p.x,dy#=plr.y-p.y
		Local d#=Sqr(dx*dx+dy*dy)
		If d=0 Then d=0.00001
		Local pan#=(ax*dx+ay*dy)/(d)
		Local vol#=Exp(-d/e)
		SetChannelPan(c,pan)
		SetChannelVolume(c,vol*v)
	End Method
End Type

Type TPos
	Field x#,y#,a#
	Method Play:TChn(s:TSound,v#=1,e#=200)
		Local c:TChn=New TChn
		c.p=Self
		c.v=v
		c.e=e
		c.Adjust()
		PlaySound(s,c.c)
		Return c
	End Method
End Type

Type TFig Extends TPos
	Field pp:TPos
	Field s%=24
	Method New()
		pp = New TPos
	End Method
	Method Update()
		Local dx#=pp.x-x,dy#=pp.y-y
		If Sqr(dx*dx+dy*dy)>s Or Abs(pp.a-a)>45
			Stp()
		EndIf
	End Method
	Method Stp()
		pp.x=x
		pp.y=y
		pp.a=a
		Play(sStp[Rand(0,7)],,150)
	End Method
	Field m%
End Type
Type TPlr Extends TFig
	Field ammo%,l%=3,t%
	Method Update()
		a:+MouseXSpeed()*0.15
		MoveMouse(gw/2,gh/2)
		MouseXSpeed()
		Local kw%=KeyDown(KEY_W)
		Local ks%=KeyDown(KEY_S)
		Local ka%=KeyDown(KEY_A)
		Local kd%=KeyDown(KEY_D)
		If kw Or ks
			Local s%=1-2*ks
			x:+Cos(a)*s
			y:+Sin(a)*s
			If Not m Then Stp()
			m=True
		EndIf
		If ka Or kd
			Local s%=1-2*kd
			x:+Sin(a)*s*0.6
			y:-Cos(a)*s*0.6
			If Not m Then Stp()
			m=True
		EndIf
		If kw+ks+ka+kd=0
			If m Then Stp()
			m=False
		EndIf
		Super.Update()
		If MouseHit(MOUSE_LEFT) Then Shoot()
		If MouseHit(MOUSE_RIGHT) And MilliSecs()>=t
			car.Play(sLck)
			t=MilliSecs()+1000
		EndIf
		Local dx#=car.x-x,dy#=car.y-y
		If Sqr(dx*dx+dy*dy)<35
			EndGame(True)
		EndIf
	End Method
	Method Shoot()
		If ammo>0
			PlaySound(sSht)
			For Local z:TZmb=EachIn zmb
				If GetD(z)<15 And z.l=True
					z.Play(sDrp)
					z.l=False
					StopChannel(z.c.c)
				EndIf
			Next
			If GetD(car)<30
				EndGame(True)
			EndIf
		Else
			PlaySound(sDry)
		EndIf
		ammo:-1
	End Method
	Method GetD#(p:TPos)
		Local ax#=Cos(a),ay#=Sin(a)
		Local bx#=p.x-x,by#=p.y-y
		If (ax*bx+ay*by)<0 Then Return 9999
		If Sqr(bx*bx+by*by)>Rand(100,400) Then Return 9999
		ax=Sin(a)
		ay=-Cos(a)
		Return Abs(ax*bx+ay*by)
	End Method
End Type
Type TZmb Extends TFig
	Field tm%,tb%,bi%,ta%
	Field m%,l%=True
	Field c:TChn
	Method Update()
		If l=False Then Return
		If MilliSecs()>=tb
			c=Play(sBrt[Rand(0,2)],0.3,50)
			tb=MilliSecs()+bi
		EndIf
		If MilliSecs()>=tm
			m=1-m
			Stp()
			If m
				tm=MilliSecs()+Rand(2000,5000)
			Else
				tm=MilliSecs()+Rand(8000,20000)
			EndIf
		EndIf
		If m
			x:+Cos(a)*0.7
			y:+Sin(a)*0.7
		EndIf
		If MilliSecs()>=ta
			Local dx#=plr.x-x,dy#=plr.y-y
			Local d#=Sqr(dx*dx+dy*dy)
			If d<70
				Play(sWsh)
				a=ATan2(dy,dx)
				If Not m Then tm=MilliSecs()
			EndIf
			If d<30
				Play(sPch)
				plr.l:-1
				If plr.l=0 Then EndGame(False)
			EndIf
			ta=MilliSecs()+800
		EndIf
		Super.Update()
	End Method
End Type

Function LGfx()
	Local gi%,w%,h%,d%,z%
	Local gc%=CountGraphicsModes()
	For Local i%=0 Until gc
		GetGraphicsMode(i,w,h,d,z)
		If w*h>gi
			gi=w*h
			gw=w
			gh=h
		EndIf
	Next
	Graphics(gw,gh,32,60)
	HideMouse()
End Function

Function LSound()
	Local ds:String[]=["FreeAudio DirectSound","FreeAudio Multimedia","FreeAudio","Null"]
	For Local d:String=EachIn ds
		If AudioDriverExists(d)
			SetAudioDriver(d)
			Exit
		EndIf
	Next
	Local i:Int
	For i=1 To 3
		sBrt[i-1]=LoadSound("sfx/brt"+i+".ogg")
	Next
	sDrp=LoadSound("sfx/drp.ogg")
	sDry=LoadSound("sfx/dry.ogg")
	sExp=LoadSound("sfx/exp.ogg")
	sLck=LoadSound("sfx/lck.ogg")
	sPch=LoadSound("sfx/pch.ogg")
	sSht=LoadSound("sfx/sht.ogg")
	For i=1 To 8
		sStp[i-1]=LoadSound("sfx/stp"+i+".ogg")
	Next
	sWsh=LoadSound("sfx/wsh.ogg")
End Function

Function EndGame(e%)
	If e Then PlaySound(sExp)
	Delay(7000)
	End
End Function